/**
 * Offset rings for tracing rough (eg jigsaw) cuts around templates
 * to save some work for the mill
 */

H = 1; // Disc thickness
Z = 0.2; // Hole thickness
D = 1; // Hole diameter
R = D / 2;

module ring(i) {
  difference() {
    cylinder(h=H, r=25.4 * i, $fn=100);
    cylinder(h=Z, r=R, $fn=50);
    translate([0,0,Z]) cylinder(h=H-Z, r1=R, r2=R+2*(H-Z), $fn=50);
  }
}

ring(1);                      // 25.4mm
translate([50,0])  ring(3/4); // 19.05mm
translate([100,0]) ring(1/2); // 12.7
translate([150,0]) ring(3/8); // 9.52
translate([200,0]) ring(1/4); // 6.35
